/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.1 Evaluation
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : "Polygon" transceiver
Version :
Date    : 13.08.2006
Author  : Freeware, for evaluation and non-commercial use only
Company :
Comments:      FIR     .  PLL.
              32.


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 14,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega8535.h>
unsigned int i;
#define FIRST_ADC_INPUT 0        //    
#define LAST_ADC_INPUT 0         //     (     0- )
unsigned int flt_x[32] @0x60;    //   (   ,    060) 32- -      
unsigned int flt_B[31] @0xA0;    //   
unsigned int flt_y[32] @0xE0;    //    , 32  -     
unsigned int flt_B1[31] @0x120;  //   
unsigned int flt_z @0x160;       //     
unsigned int flt_gain @0x162;    //  
unsigned int sig_peak;           //     
unsigned int trx=0;              //        :  0- ,  =0-  .
unsigned int cw_beep=0;          //     (0-   >0- )
unsigned int cw_pause=0;         //    (>0-   )
unsigned int ddot=250;           //  
unsigned int dash=750;           //  

unsigned int trx_pause=0;     //   
int fgen=512;                    //   (     )
unsigned int frx=512;  //880       //  
int dfrx=1;                      //       (0...1023)
#define ADC_VREF_TYPE 0xC0       //      


//     2 (Timer 2 output compare interrupt service routine)
// 2   32           -
//    
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{

if (trx==0){ ADCSRA|=0x40;};  //  ,    
if (trx_pause==0){
//   ,         trx   :
if (trx>0)
        {trx--;
        if (cw_beep>0) {cw_beep--; if (OCR1A>0) {OCR1A=0;} else {OCR1A=1023;};};       
        if (cw_pause>0 && cw_beep==0) {cw_pause--;};
        };                      
                  } else { trx_pause--;};



if (dfrx>50){
if ((PINC & 0x02)==0 && frx>192){frx--;};     //     (  1) -   ,      
if ((PINC & 0x04)==0 && frx<1022){frx++;};  //  (  2)-   
dfrx=0;} else {dfrx++;};
if (trx>0) {OCR1B=frx-192;} else {OCR1B=frx;};//      -     500  (1024*500/8000=64)
}   


//      (ADC interrupt service routine)        
//     ,       0
interrupt [ADC_INT] void adc_isr(void)
{
//register static unsigned char input_index=0;

ADMUX=(FIRST_ADC_INPUT|ADC_VREF_TYPE);  //+input_index;  //      0


//           
//  .    FIR-
//------------------------------------------------------------------------------------

#asm
push R0
push R1
push R2
push R16
push R17
push R18
push R19
push R20
push R21
push R22
push R23
push R24
push R25
push R26
push R27
push R28        ; 
push R29        ;
push R30        ;     


        clr     R2
        clr R22 ;Clear avg Low byte
        clr R23
        clr R24 ;Clear avg Low byte
        clr R25
        clr R26 ;Clear avg Low byte
        clr R27
        clr R28 ;Clear avg Low byte
        clr R29
        clr     R30
mav8_3:

        ldi     R28, $60        ;      


        IN      R22,0x4 ;      
         IN      R23,0x4+1

        cpi     R23, $04        ;       3,    ,     ,  - 
        brsh    ovfl2

        cpi     R22, $F0        ;       F0,   ,      9E
        brlo    no_ovfl2

ovfl2:
        ldi     R23, $03        ;   ,     03F0
        ldi     R22, $F0    

no_ovfl2:
        sts     $9E, R22        ;  ,         
        sts     $9F, R23        ;      


 c11:
        ldd R22,Y+2             ;     
        ldd R23,Y+3             ;(Y=R28)
        std     Y+0, R22        ;
        std     Y+1, R23        ;

        inc R28
        inc R28
        ldd R20,Y+62              ;  32 ,   
                                  ;ldd R21,Y+65        ;    - - <32
        dec R28
        dec R28        

        clr     R2
        cpi     R20, $1F
        brlo    neg1

        subi     R20, $1F
        mul     R22, R20        ;    ,    
        movw    R17:R16, R1:R0

        mul     R23, R20        ;      
        add     R17, R0         ;    -   
        adc     R18, R1
                                ;adc     R19, R2 -  , ..       - 3*32=96

       
        add     R24,R16         ; 4     R24-R27
        adc     R25,R17
        adc     R26,R18
        rjmp    next_i
                                ;adc     R27,R19   ;(R19  , ..    ,   )

neg1:
        ldi     R16, $1F
        sub     R16, R20
        mov     R20, R16
        
        mul     R22, R20        ;    ,    
        movw    R17:R16, R1:R0

        mul     R23, R20        ;      
        add     R17, R0         ;    -   
        adc     R18, R1

        sub     R24,R16         ; 4     R24-R27
        sbc     R25,R17
        sbc     R26,R18


next_i:
        adiw    R29:R28,$02     ; R28  2, ..      (    )  
        inc     R30             ;  

        cpi     R30,$1F         ;    31,    ,        
        brlo    c11





        clr     R28             ; ,           , ..  

div_cl2:
                                ;lsr R27 ;-   ,   
        lsr R26                 ;       2,     ,   
        ror R25                 ;(..     10 ,    )
                                ;ror R24 ;  ,    256

        inc     R28
        cpi     R28,$06         ;     (1024*32*32/256=4096, 4096/1024=4, 2^2=4)
        brlt    div_cl2

         clc                    ;    

        ;cpi     R28,$08         ;     
        ;brlt    no_ovfl1

        sts     $11E, R25       ;       
        sts     $11F, R26       ;     



        clr     R2
        clr     R30                   
        clr     R29
        ldi     R28, $E0        ;     


        rjmp    no_ovfl1

 c13:
        ldd     R22,Y+2         ;     
        ldd     R23,Y+3         ;(Y=R28)
        std     Y+0, R22        ;
        std     Y+1, R23        ;

        inc R28
        inc R28
        ldd R20,Y+62            ;  32 ,   
                                  ;ldd R21,Y+65        ;    - - <32
        dec R28
        dec R28        

        clr     R2
        cpi     R20, $1F
        brlo    neg2

        subi     R20, $1F
        mul     R22, R20        ;    ,    
        movw    R17:R16, R1:R0

        mul     R23, R20        ;      
        add     R17, R0         ;    -   
        adc     R18, R1
                                ;adc     R19, R2 -  , ..       - 3*32=96

        add     R24,R16 ; 4     R24-R27
        adc     R25,R17
        adc     R26,R18
                                ;adc     R27,R19   ;(R19  , ..    ,   )
        rjmp    next_k
                                ;adc     R27,R19   ;(R19  , ..    ,   )

neg2:
        ldi     R16, $1F
        sub     R16, R20
        mov     R20, R16
        
        mul     R22, R20        ;    ,    
        movw    R17:R16, R1:R0

        mul     R23, R20        ;      
        add     R17, R0         ;    -   
        adc     R18, R1

        sub     R24,R16         ; 4     R24-R27
        sbc     R25,R17
        sbc     R26,R18


next_k:
        adiw    R29:R28,$02     ; R28  2, ..      (    )  
        inc     R30             ;  

        cpi     R30,$1F         ;    31,    ,        
        brlo    c13


        clr     R28
div_cl4:
        ;lsr R27                ;   2   
        ;ror R26                ;
        ;ror R25                ;
        ;ror R24                ;
       
        lsr R26                 ;       2,     ,   
        ror R25                 ;(..     10 ,    )

       
        inc     R28
        cpi     R28,$06
        brlt    div_cl4
        clc                     ;    

no_ovfl1:

        sts     $160, R25       ;      flt_z
        sts     $161, R26               


pop R30
pop R29
pop R28
pop R27
pop R26
pop R25
pop R24
pop R23
pop R22
pop R21
pop R20
pop R19
pop R18
pop R17
pop R16
pop R2
pop R1
pop R0

#endasm

OCR1A=flt_z;  //  -        

}

//   .      (/)
//  / 
void main(void)
{

//   /
//   
//     ,  
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

//   B
//    3   ,  
//  3 - 
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T
PORTB=0x00;
DDRB=0x08;

//   
//  7,6,3,2,1,0 - , 5,4 - 
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=0 State4=0 State3=P State2=P State1=P State0=P
PORTC=0xFF; //0C
DDRC=0x18; //3C

//   D
//  5,4 -  ( ),  - 
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T
PORTD=0xFF;
DDRD=0x30;

//   0
//  :  
//  : 14000,000 kHz
// : Normal top=FFh
// OC0 :      
TCCR0=0x19;      
TCNT0=0x00;
OCR0=0x01;     // 14000/(2*(1+OCR))=3,500 MHz   //14000/64(presc)/55(0x37)=3.9773 kHz    1.9886

//   1
//  :  
//  : 14000,000 kHz
// : Fast PWM top=03FFh ( )
// OC1A : Non-Inv.
// OC1B : Inverted
//   : On
//    
//    1 
//   : Off
//      : Off
//      : Off
TCCR1A=0xF3;     
TCCR1B=0x89;            
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0xFF;
OCR1BH=0x00;
OCR1BL=0xFF;            //14000/1(presc)/1024(fast PWM top=03FFh)=13.672 kHz


//   2
// : 32 
// : Normal top=FFh
// OC2 output: Disconnected
ASSR=0x08;      //08;      // Clock source: External Clock  //0x00 -   !!!!!
TCCR2=0x09;     //CTC, no prescaling              //0C;     //04(/64) //CTC no Normal mode, OC2 off, presc=64
TCNT2=0x00;
OCR2=0x06;      //32000/6=5,33kHz Compare Match on 06,    32   6.      

//    ( )
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

//    /
TIMSK=0x80; //  T0  -  ,   2 -   32 

//  
// Analog Comparator: Off ()
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

//  
//   : ,    AREF
//    ,   
ADMUX=FIRST_ADC_INPUT|ADC_VREF_TYPE;
ADCSRA=0xDA; //    ,      2
SFIOR&=0x0F; //
SFIOR|=0x70; //

//        FIR-.
//    /  
// 700/950 Hz;
flt_B[0]=41;
flt_B[1]=80;
flt_B[2]=34;
flt_B[3]=24;
flt_B[4]=8;
flt_B[5]=10;
flt_B[6]=28;
flt_B[7]=51;
flt_B[8]=61;
flt_B[9]=49;
flt_B[10]=21;
flt_B[11]=0;
flt_B[12]=0;
flt_B[13]=24;
flt_B[14]=54;
flt_B[15]=67;
flt_B[16]=54;
flt_B[17]=24;
flt_B[18]=0;
flt_B[19]=0;
flt_B[20]=21;
flt_B[21]=49;
flt_B[22]=61;
flt_B[23]=51;
flt_B[24]=28;
flt_B[25]=10;
flt_B[26]=8;
flt_B[27]=24;
flt_B[28]=34;
flt_B[29]=80;
flt_B[30]=41;



// 700/950 Hz;
flt_B1[0]=41;
flt_B1[1]=80;
flt_B1[2]=34;
flt_B1[3]=24;
flt_B1[4]=8;
flt_B1[5]=10;
flt_B1[6]=28;
flt_B1[7]=51;
flt_B1[8]=61;
flt_B1[9]=49;
flt_B1[10]=21;
flt_B1[11]=0;
flt_B1[12]=0;
flt_B1[13]=24;
flt_B1[14]=54;
flt_B1[15]=67;
flt_B1[16]=54;
flt_B1[17]=24;
flt_B1[18]=0;
flt_B1[19]=0;
flt_B1[20]=21;
flt_B1[21]=49;
flt_B1[22]=61;
flt_B1[23]=51;
flt_B1[24]=28;
flt_B1[25]=10;
flt_B1[26]=8;
flt_B1[27]=24;
flt_B1[28]=34;
flt_B1[29]=80;
flt_B1[30]=41;


//  
flt_gain=8;

//  
#asm("sei")

//,    -    3   LED
PORTC=0xE7;
for (i=0;i<10000;i++) {};
PORTC=0xF7;               //  ,
for (i=0;i<10000;i++) {};
PORTC=0xE7;               //  ...
for (i=0;i<10000;i++) {};
PORTC=0xF7;
for (i=0;i<10000;i++) {};
PORTC=0xE7;
for (i=0;i<10000;i++) {};
PORTC=0xF7;

//      
cw_pause=0;
cw_beep=0;//      100,      3  LED   .

//  -    
//     ,         
//  trx    (     )

while (1)
      {
//sig_peak=sig_peak-1;
//if (sig_peak<flt_z) {sig_peak=sig_peak+1;} else {sig_peak=sig_peak-1;};
//if (sig_peak<700) {PORTC=0x00; if (flt_gain>6){flt_gain=flt_gain-1;}} else {PORTC=0xFF; if (flt_gain<10) {flt_gain=flt_gain+1;}};


if ((PIND & 0x01)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=dash; cw_pause=ddot; trx=ddot+dash+ddot+2*dash;}; //else {next_cw_beep=dash;};
if ((PIND & 0x02)==0 && cw_pause==0) {if (trx==0){ trx_pause=ddot;}; cw_beep=ddot; cw_pause=ddot; trx=ddot+ddot+ddot+2*dash;}; //else {next_cw_beep=ddot;}; //&& cw_beep==0 && cw_pause==0

if (cw_beep>0 && trx_pause==0) {PORTC|=0x18; if (DDRB==0x00){DDRB=0x08;}; cw_pause=ddot;} else {PORTC&=0xEF; if (DDRB==0x08 && trx>0){DDRB=0x00;};}; // ,   LED,   -  ( ,  4)
if (trx>0) {PORTC|=0x08;} else {PORTC&=0xF7; if (DDRB==0x00){DDRB=0x08;};}; //   ,       ( ,  3),     -  

      };
} 